# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`s3daemon`](#s3daemon): Client/server for pushing objects to S3 storage.

### Defined types

* [`s3daemon::instance`](#s3daemon--instance): Deploy the s3daemon service

## Classes

### <a name="s3daemon"></a>`s3daemon`

Client/server for pushing objects to S3 storage.

#### Parameters

The following parameters are available in the `s3daemon` class:

* [`instances`](#-s3daemon--instances)

##### <a name="-s3daemon--instances"></a>`instances`

Data type: `Optional[Hash[String[1], Hash]]`

A hash of instances to configure. The key is the instance name and the value
is a hash of `s3daemon::instance` parameters.

Default value: `undef`

## Defined types

### <a name="s3daemon--instance"></a>`s3daemon::instance`

Deploy the s3daemon service

#### Parameters

The following parameters are available in the `s3daemon::instance` defined type:

* [`s3_endpoint_url`](#-s3daemon--instance--s3_endpoint_url)
* [`aws_access_key_id`](#-s3daemon--instance--aws_access_key_id)
* [`aws_secret_access_key`](#-s3daemon--instance--aws_secret_access_key)
* [`port`](#-s3daemon--instance--port)
* [`image`](#-s3daemon--instance--image)
* [`volumes`](#-s3daemon--instance--volumes)

##### <a name="-s3daemon--instance--s3_endpoint_url"></a>`s3_endpoint_url`

Data type: `Stdlib::HTTPUrl`

The URL of the S3 endpoint to which the s3daemon service will send files.

##### <a name="-s3daemon--instance--aws_access_key_id"></a>`aws_access_key_id`

Data type: `Variant[String[1], Sensitive[String[1]]]`

The AWS access key ID to use for authentication.

##### <a name="-s3daemon--instance--aws_secret_access_key"></a>`aws_secret_access_key`

Data type: `Variant[String[1], Sensitive[String[1]]]`

The AWS secret access key to use for authentication.

##### <a name="-s3daemon--instance--port"></a>`port`

Data type: `Stdlib::Port`

The tcp port on which the s3daemon service will listen.
Default: 16666

Default value: `15556`

##### <a name="-s3daemon--instance--image"></a>`image`

Data type: `String[1]`

The container image to use for the s3daemon service.

Default value: `'ghcr.io/lsst-dm/s3daemon:main'`

##### <a name="-s3daemon--instance--volumes"></a>`volumes`

Data type: `Array[Stdlib::Absolutepath]`

An array of volumes to mount in the container. Uses the format
'/host:/contaner'.  E.g. ['/home:/home', '/data:/data']

Default: ['/home:/home']

Default value: `['/home:/home']`

